package info.textgrid.middleware;

import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Response;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import info.textgrid.utils.httpclient.TGHttpConnection;

/**
 *
 */
public class Rest {

  private Log log = LogFactory.getLog(Rest.class);

  /**
   * @return
   */
  @GET
  @Path("/buildinfo")
  @Produces("text/html")
  public String getBuildInfo() {

    InputStream is = this.getClass().getResourceAsStream("buildinfo.txt");
    Properties prop = new Properties();
    try {
      prop.load(is);
    } catch (IOException e) {
      return "error opening buildinfo.txt";
    } finally {
      try {
        is.close();
      } catch (IOException e) {
        this.log.error("error closing stream", e);
      }
    }

    String info = "this is oaipmh " + prop.get("version") + " built "
        + prop.get("time") + " from git: " + prop.get("branch")
        + " (rev:" + prop.get("build") + ")";

    return info;
  }

  /**
   * @return
   */
  @GET
  @Path("/cmstat")
  @Produces("text/plain")
  public Response getConManStat() {

    String[] routes = {};
    String cmstats = TGHttpConnection.generateInfoString(routes);

    return Response.ok(cmstats).build();
  }

}
